package com.scurab.dictgen;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

public class Keyboard {

	public ArrayList<Row> rows = new ArrayList<Keyboard.Row>();
	
	
	public int getRowIndex(char c)
	{
		for(int i = 0;i<rows.size();i++)
		{
			Row r = rows.get(i);
			if(r.getIndexOfKey(c) > -1)
				return i;
		}
		return -1;
	}
	
	public Key getKey(float x, float y)
	{
		for(int i = 0;i<rows.size();i++)
		{
			Row r = rows.get(i);
			if(r.isInY(y))
			{
				for(int j = 0;j<r.keys.size();j++)
				{
					Key k = r.keys.get(j);
					if(k.isInX(x))
						return k;
				}
			}
		}
		return null;
	}
	
	public ArrayList<PointF> getPoints(String text)
	{
		ArrayList<PointF> list = new ArrayList<PointF>();
		
		char[] chars = text.toLowerCase().toCharArray();
		for(char c : chars)
		{
			int rowIndex = this.getRowIndex(c);
			if(rowIndex != -1)
			{
				Row row = this.rows.get(rowIndex);
				int keyIndex = row.getIndexOfKey(c);
				Key k = row.keys.get(keyIndex);
				PointF point = new PointF();
				point.y =  (rowIndex * row.height + row.height/2);
				point.x =  k.getCenterX();
				list.add(point);
			}
		}
		return list;
	}
	
	public class Row
	{
		ArrayList<Key> keys = new ArrayList<Keyboard.Key>();
		public float height;
		public float top;
		
		public int getIndexOfKey(char c)
		{
			for(int i = 0;i<keys.size();i++)
			{
				Key k = keys.get(i);
				if(k.c == c)
					return i;
			}
			return -1;
		}				
		
		public boolean isInY(float y)
		{
			return (this.top < y && y < this.top + height);
		}
	}
	
	public class Key
	{
		public char c;
		public int code;
		public int x;
		public int y;
		public float width;
		public float left;
		
		public float getCenterX()
		{
			return this.left + this.width/2 ;
		}
		
		public boolean isInX(float x)
		{
			return (x > this.left && x < this.left + width);
				
		}
	}
}
