package com.scurab.dictgen;

public class Params
{
	public String dbOutputFile = "";
	public String baseWordFile = "";
	public String suffixFile = "";
	
	public String userSourceFile = null;
	public boolean appendToUserDB = false;
//	public String userSourceFile = "";
	
	public static Params parse(String[] args)
	{
		Params p = new Params();
		
		for(String arg : args)
		{
			String[] arr = arg.split("=");
			
			if(arr.length == 1 && arr[0].equals("/userSource"))
				arr = new String[]{"/userSource",""};
			else if(arr.length != 2)
				System.err.printf("%s ignoring...\n", arg);
			
			String param = arr[0];
			String paramVal = arr[1];
			
			if(param.equals("/dbOut"))
				p.dbOutputFile = paramVal;
			else if (param.equals("/words"))
				p.baseWordFile = paramVal;
			else if (param.equals("/suffixes"))
				p.suffixFile = paramVal;
			else if (param.equals("/userSource"))
				p.userSourceFile = paramVal;
			else if (param.equals("/appendToUserDB"))
				p.appendToUserDB = Boolean.parseBoolean(paramVal);
			else
				System.err.printf("Unknown param %s => ignoring...\n", arg);
		}
		
		return p;
	}
}
