package com.scurab.dictgen;

import java.io.File;
import java.io.IOException;
import java.sql.SQLException;

public class Program {

	/**
	 * @param args
	 * @throws Exception 
	 */
	
	public static void mainA(String[] args) throws Exception {
		Params p = new Params();
		p.dbOutputFile = "c:\\Temp\\Android8\\czech12.db";
		p.suffixFile = "c:\\Temp\\Android7\\_AndroidDictionaries\\limit12\\suffy.txt";
		DBGenerator dgb = null;
		dgb = new DBGenerator(p);		
		dgb.startGenDefaultDB();
			
	} 
	
	public static void main(String[] args) {
		Params p = null;
		try
		{
			if(args.length == 0) throw new Exception();
			p = Params.parse(args);
		}
		catch(Exception e )
		{
			showHelp();
			return;
		}
		
		DBGenerator dgb = null;
		try		
		{
			File f = new File(p.dbOutputFile);
//			if(f.exists()) f.delete();
			if(f.exists() && !p.appendToUserDB) throw new Exception(String.format("Soubour %s uz existuje!",p.dbOutputFile));
			dgb = new DBGenerator(p);
			if(p.userSourceFile == null)
				dgb.startGenDefaultDB();
			else
			{
				if(p.userSourceFile.length() == 0)
					dgb.createEmptyUserDatabase();
				else
					dgb.startGenUserDB();
			}
			dgb.close();
		}
		catch(Exception e)
		{
			System.err.println(e.getMessage());
			e.printStackTrace();
		}
		System.out.println("Done...");
	}
	
	public static void showHelp()
	{
		System.out.println("Error in parameters!");
		System.out.println("Example /dbOut=\"C:\\test.db\" /words=\"c:\\list.txt\" /suffixes=\"c:\\suffy.txt\"");
		System.out.println("Example /dbOut=\"C:\\test-user.db\" /userSource=\"C:\\myfile.txt\"  /append=true - gen user db and fill with data from myfile.txt" );
		System.out.println("Example /dbOut=\"C:\\android\\czech-user.db\" /userSource=\"\" - gen user empty dbs" );
	}
	
	public static void mainX(String[] args) throws ClassNotFoundException, SQLException, NumberFormatException, IOException {
		// TODO Auto-generated method stub
		Test t = new Test();
		t.Start();		
	}
}
