package com.scurab.dictgen;

import java.util.HashSet;

public class Stringology {

	public static String getGeneralizedString(String word)
	{
		StringBuilder sb = new StringBuilder(word.length());
		char[] chars = word.toCharArray();
		for(char c: chars)
		{
			sb.append(getGeneralizedChar(c));
		}
		return sb.toString();
	}
	
	public static String getMoreGeneralizedString(String word)
	{
		StringBuilder sb = new StringBuilder(word.length());
		char[] chars = word.toCharArray();
		for(char c: chars)
		{
			sb.append(getMoreGeneralizedChar(c));
		}
		return sb.toString();
	}
	
	public static String getGeneralizedCharRev(char c)
	{
		StringBuilder sb = new StringBuilder();
		char[] abeceda = "abcdefghijklmnopqrstuvwxyz".toCharArray();
		for(char ch : abeceda)
		{
			if(getGeneralizedChar(ch) == c)
				sb.append(ch);
		}
		return sb.toString();
	}
	
	public static String getMoreGeneralizedCharRev(char c)
	{
		StringBuilder sb = new StringBuilder();
		char[] abeceda = "abcdefghijklmnopqrstuvwxyz".toCharArray();
		for(char ch : abeceda)
		{
			if(getMoreGeneralizedChar(ch) == c)
				sb.append(ch);
		}
		return sb.toString();
	}
	
	public static char getGeneralizedChar(char c)
	{
		c = Character.toLowerCase(c);
		switch(c)
		{
			//first line
			case 'q': case 'w': case 'ẁ': case 'ẃ': case 'ŵ': case 'ẅ':
				c = 'q';
				break;				
			case 'e': case 'è': case 'é': case 'ě': case 'ê': case 'ë': case 'ē': case 'r': case 'ŗ': case 'ŕ': case 'ř': case 't': case 'ţ': case 'ť': case 'ŧ':
				c = 'e';
				break;
			case 'y': case 'ỳ': case 'ý': case 'ŷ': case 'ÿ': 
			case 'u': case 'ù': case 'ú': case 'û': case 'ũ': case 'ü': case 'ů': case 'ū': case 'ŭ': case 'ų': case 'ű': 
			case 'i': case 'ì': case 'í': case 'î': case 'ĩ': case 'ï': case 'ī': case 'ĭ': case 'į': case 'ı':
				c = 'u';
				break;
			case 'o': case 'ò': case 'ó': case 'ô': case 'õ': case 'ö': case 'ō': case 'p':
				c = 'p';
				break;
			
				//next line
			case 'a': case 'à': case 'á' :case 'â': case 'ã': case 'ä': case 'å': case 'ā': case 'ă': case 'ą': case 'ǻ': case 'æ': case 'ǽ':
			case 's': case 'ś': case 'ş': case 'š': case 'ŝ':
			case 'd': case 'ď': case 'đ': case 'ð':
				c = 's';
				break;
			case 'f': case 'g': case 'ğ': case 'ġ': case 'h': case 'ĥ': case 'ħ':
				c = 'g';
				break;
			case 'j': case 'ĵ': case 'k': case 'ķ': case 'l': case 'ĺ': case 'ļ': case 'ľ': case 'ŀ': case 'ł': 
				c = 'k';
				break;

				//nextline
			case 'z': case 'ź': case 'ž': case 'ż': case 'x': 
				c = 'z';
				break;
			case 'c': case 'ć': case 'ç': case 'č': case 'ĉ': case 'ċ': case 'v':  case 'b': 
				c = 'c';
				break;
			case 'n': case 'ń': case 'ņ': case 'ň': case 'ñ': case 'm':
				c = 'n';
				break;
			default:											
				//throw new Exception(String.format("Unhandled char (%s)",c));
		}		
		return c;
	}
	
	public static char getMoreGeneralizedChar(char c)
	{
		c = Character.toLowerCase(c);
		switch(c)
		{
			//first line
			case 'q': case 'w': case 'ẁ': case 'ẃ': case 'ŵ': case 'ẅ':
			case 'e': case 'è': case 'é': case 'ě': case 'ê': case 'ë': case 'ē': case 'r': case 'ŗ': case 'ŕ': case 'ř': case 't': case 'ţ': case 'ť': case 'ŧ':
				c = 'e';
				break;				
			case 'y': case 'ỳ': case 'ý': case 'ŷ': case 'ÿ': 
			case 'u': case 'ù': case 'ú': case 'û': case 'ũ': case 'ü': case 'ů': case 'ū': case 'ŭ': case 'ų': case 'ű': 
			case 'i': case 'ì': case 'í': case 'î': case 'ĩ': case 'ï': case 'ī': case 'ĭ': case 'į': case 'ı':
			case 'o': case 'ò': case 'ó': case 'ô': case 'õ': case 'ö': case 'ō': case 'p':
				c = 'i';
				break;
				//next line
			case 'a': case 'à': case 'á' :case 'â': case 'ã': case 'ä': case 'å': case 'ā': case 'ă': case 'ą': case 'ǻ': case 'æ': case 'ǽ':
			case 's': case 'ś': case 'ş': case 'š': case 'ŝ':
			case 'd': case 'ď': case 'đ': case 'ð':
			case 'f': case 'g': case 'ğ': case 'ġ': 
				c = 'd';
				break;
			case 'h': case 'ĥ': case 'ħ':
			case 'j': case 'ĵ': case 'k': case 'ķ': case 'l': case 'ĺ': case 'ļ': case 'ľ': case 'ŀ': case 'ł': 
				c = 'k';
				break;

				//nextline
			case 'z': case 'ź': case 'ž': case 'ż': case 'x':
			case 'c': case 'ć': case 'ç': case 'č': case 'ĉ': case 'ċ': case 'v':  
				c = 'c';
				break;
		    case 'b':
			case 'n': case 'ń': case 'ņ': case 'ň': case 'ñ': case 'm':
				c = 'n';
				break;
			default:											
				//throw new Exception(String.format("Unhandled char (%s)",c));
		}		
		return c;
	}
	
	public static String getNormalizedString(String word)
	{
		StringBuilder sb = new StringBuilder(word.length());
		char[] chars = word.toCharArray();
		for(char c: chars)
		{
			sb.append(getNormalizedChar(c));
		}
		return sb.toString();
	}
	
	public static String getConsonants(String word)
	{
		StringBuilder sb = new StringBuilder(word.length());
		word = Stringology.getNormalizedString(word);
		char[] chars = word.toCharArray();
		for(char c: chars)
		{
			if(!(c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u' ))
				sb.append(c);
		}
		return sb.toString();
	}
	
	public static String getSearchForConsonants(String word)
	{
		StringBuilder sb = new StringBuilder(word.length());
		word = Stringology.getNormalizedString(word);
		char[] chars = word.toCharArray();
		for(int i = 0;i<chars.length;i++)
		{
			char c = getNormalizedChar(chars[i]);
			if(i > 0 && i < chars.length - 1)
			{
				if(!(c == 'a' || c == 'e' || c == 'i' ||  c == 'y' || c == 'o' || c == 'u' ))
					sb.append(c);
			}
			else
				sb.append(c);
		}
		return sb.toString();
	}
	
	public static char getNormalizedChar(char c)
	{
		boolean isLower = Character.isLowerCase(c);
		if(!isLower)
			c = Character.toLowerCase(c);
		
		switch(c)
		{
			case 'w': case 'ẁ': case 'ẃ': case 'ŵ': case 'ẅ':
				c = 'w';break;							
			case 'e': case 'è': case 'é': case 'ě': case 'ê': case 'ë': case 'ē':
				c = 'e';break;
			case 'ŗ': case 'ŕ': case 'ř':
				c = 'r';break;
			case 'ţ': case 'ť': case 'ŧ':
				c = 't';break;
			case 'ỳ': case 'ý': case 'ŷ': case 'ÿ':
				c = 'y';break;
			case 'ù': case 'ú': case 'û': case 'ũ': case 'ü': case 'ů': case 'ū': case 'ŭ': case 'ų': case 'ű':
				c = 'u';break;
			case 'ì': case 'í': case 'î': case 'ĩ': case 'ï': case 'ī': case 'ĭ': case 'į':
				c = 'i';break;
			case 'ò': case 'ó': case 'ô': case 'õ': case 'ö': case 'ō':
				c = 'o';		break;		
			case 'à': case 'á' :case 'â': case 'ã': case 'ä': case 'å': case 'ā': case 'ă': case 'ą': case 'ǻ': case 'æ': case 'ǽ':
				c = 'a';break;
			case 'ś': case 'ş': case 'š': case 'ŝ':
				c = 's';break;
			case 'ď': case 'đ': case 'ð':
				c = 'd';break;
			case 'ğ': case 'ġ':
				c = 'g';break;
			case 'ĥ': case 'ħ':
				c = 'h';break;
			case 'ĵ': 
				c = 'j';break;
			case 'ķ': 
				c = 'k';break;
			case 'ĺ': case 'ļ': case 'ľ': case 'ŀ': case 'ł':
				c = 'l';break;
			case 'ź': case 'ž': case 'ż':				
				c = 'z';break;
			case 'ć': case 'ç': case 'č': case 'ĉ': case 'ċ':
				c = 'c';break;
			case 'ń': case 'ņ': case 'ň': case 'ñ':	
				c = 'n';break;				
		}
		if(!isLower)
			c = Character.toUpperCase(c);
		return c;		
	}
	
	public static String removeDuplicateCharacters(String source)
	{
		if (source.length() == 0)
			return source;
		StringBuilder sb = new StringBuilder();
		char[] chars = source.toCharArray();
		char lastchar = chars[0];
		sb.append(lastchar);

		for (int i = 1; i < chars.length; i++)
		{
			char ch = chars[i];
			if (ch != lastchar)
			{
				sb.append(ch);
				lastchar = ch;
			}
		}
		return sb.toString();
	}
	
	/**
	 * Removes duplicate words in text
	 * @param text
	 * @return
	 */
	public static String getDistinctWords(String text)
	{
		HashSet<String> hs = new HashSet<String>();
		String[] words = text.split(" ");
		StringBuilder sb = new StringBuilder();
		for (String w : words)
		{
			w = w.trim();
			if (!hs.contains(w))
			{
				sb.append(w + " ");
				hs.add(w);
			}
		}
		return sb.substring(0, sb.length() - 1);
	}
}
