package com.scurab.dictgen;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;

public class Test {
	
	public Test() throws ClassNotFoundException, SQLException {
		// TODO Auto-generated constructor stub
		Class.forName("org.sqlite.JDBC");
		//String file = "C:\\temp\\android6\\czech8.db";
		String file = "c:\\Temp\\Android8\\czech12.db";
	    this.conn = DriverManager.getConnection("jdbc:sqlite:" + file);
	    this.stat = conn.createStatement();
	    this.stat.execute("PRAGMA synchronous = 0;");
	}
	
	public void Start() throws SQLException, NumberFormatException, IOException
	{
		this.checkForShortWordsInLongWay();
	}
	
	private void checkForShortWordsInLongWay() throws SQLException
	{
		String sql = "Select tablename FROM map ORDER BY prefix";
		ResultSet rs = this.stat.executeQuery(sql);
		ArrayList<String> tabs = new ArrayList<String>();				
		while(rs.next())			
		{
			String table = rs.getString("tablename");	
			tabs.add(table);
		}
		
		ArrayList<StructCorrect> toRepair = new ArrayList<StructCorrect>();
		
		for(String table : tabs)
		{
			String sqlTpl = String.format("Select * FROM [%s] WHERE wrdlen <= %s AND suffix > 0",table,table.length());
			rs = this.stat.executeQuery(sqlTpl);
			while(rs.next())
			{
				String word = rs.getString("wordbase");
				boolean isOk = isCorrectLength(tabs,word);
				StructCorrect sc = new StructCorrect();
				sc.table = table;
				sc.word = word;
				toRepair.add(sc);
				//if(!isOk)
					System.out.printf("table:%s word:%s isOk:%s\n",table,word,isOk);
			}
			rs.close();
		}
		
		
	}
	
	class StructCorrect
	{
		public String word;
		public String table;
	}
	
	private boolean isCorrectLength(List<String> tables,String word)
	{
		String contName = Character.toUpperCase(word.charAt(0)) + Stringology.getGeneralizedString(word.substring(1));
		int len = contName.length();
		for(String tbl: tables)
		{
			if(tbl.startsWith(contName))
			{
				int tblLen = tbl.length();
				if(tblLen > len)
					len = tbl.length();
			}
		}
		return !(len > word.length());
	}
	
	private void makeTables() throws NumberFormatException, SQLException, IOException
	{
		for(int i = 500;i<15000;i = i + 500)
		{
			String table = "C" + i; 
			createTable(table,false);
			String it = "INSERT INTO " + table + " (wordbase, normwordbase, searchtext, gensearchtext,  swype, genswype, isbwu, suffix, cntr, wrdlen) ";
			String sqlt = it + "select wordbase, normwordbase, searchtext, gensearchtext, swype,genswype, isbwu, suffix, cntr, wrdlen " +
			  "FROM COMPLETE WHERE wordbase MATCH 'n*' LIMIT " + i;
			this.stat.execute(sqlt);
		}
	}
	
	private void createTable(String table, boolean overwrite) throws SQLException, NumberFormatException, IOException
	{				
		String template = "CREATE VIRTUAL TABLE  \"%s\" USING fts3(\"wordbase\" TEXT NOT NULL UNIQUE, \"normwordbase\" TEXT NOT NULL, \"searchtext\" TEXT NOT NULL, \"gensearchtext\" TEXT NOT NULL,  \"swype\" TEXT NOT NULL, \"genswype\" TEXT NOT NULL, \"isbwu\" INTEGER NOT NULL, \"suffix\" INTEGER NOT NULL, \"cntr\" INTEGER INTEGER DEFAULT 0, \"wrdlen\" INTEGER NOT NULL, \"profil\" INTEGER );";								
		String sql = null;		
		//for(String key : tables)
		{
			//String table = this.tableMap.get(key);
			if(overwrite)
			{
				sql = String.format("DROP TABLE IF EXISTS \"%s\"; ",table);
				this.stat.execute(sql);
			}			
			//if(!this.existsTable(table))
			{
				sql = String.format(template,table);
				stat.executeUpdate(sql);		
			}
		}
	}
	
	private String testStringy(String prefix, int lenToKeep)
	{
		int len = prefix.length() - lenToKeep;
		String fixPrefix = prefix.substring(0,len+1);
		StringBuilder sb = new StringBuilder();
		char[] genPostfixy = prefix.substring(len).toCharArray();
		for(char c : genPostfixy)
		{
			String normPost = Stringology.getMoreGeneralizedCharRev(c);
			char[] npChars = normPost.toCharArray();
			for(char cc:npChars)
			{
				String q = "normwordbase LIKE '" + fixPrefix + cc + "%' OR ";
				sb.append(q);
			}
		}
		return sb.substring(0,sb.length() - " OR ".length());
	}
	
	private void testSizes() throws SQLException
	{
		String abeceda = "abcdefghijklmnopqrstuvwxyz".toUpperCase();
		String genabeceda = getDistinctString(Stringology.getGeneralizedString(abeceda));
		String mgenabeceda = getDistinctString(Stringology.getMoreGeneralizedString(abeceda));
		char[] chars = abeceda.toCharArray();
		char[] genchars = genabeceda.toCharArray();
		char[] mgenchars = mgenabeceda.toCharArray();
		
		for(int i = 0;i<chars.length;i++)
		{			
			String c = String.valueOf(chars[i]);
			String sql = String.format("Select COUNT(*) as pocet FROM COMPLETE WHERE normwordbase MATCH '%s*'",c);
			ResultSet rs = this.stat.executeQuery(sql);
			int pocet = 0;
			if(rs.next())
			{
				pocet = rs.getInt(1);
				System.out.println(String.format("CHAR:%s Count:%S",c,pocet));
			}
			rs.close();
			if(pocet > 1500)
			{
				testSubSize(c.toLowerCase(), null, 2);
			}
		}
	}
	
	public void testSubSize(String whereNormWordCondition, String whereGenWordCondition, int level) throws SQLException
	{
		String whereToSQL = whereNormWordCondition;
		String whereToSQL2 = whereGenWordCondition;
		if(!whereToSQL.contains(" ")) 
			whereToSQL = "normwordbase LIKE '" + whereToSQL + "%'";
		
		if(whereGenWordCondition != null) 
			whereToSQL2 = "genwordbase LIKE '" + whereToSQL2 + "%'";
		
		String sql = null;
		if(whereGenWordCondition == null)
			sql = String.format("Select COUNT(*) as pocet, substr(genwordbase,0,%s) as iq  FROM COMPLETE WHERE %s GROUP BY substr(genwordbase,0,%s)",level,whereToSQL,level);
		else
			sql = String.format("Select COUNT(*) as pocet, substr(genwordbase,0,%s) as iq  FROM COMPLETE WHERE %s AND %s  GROUP BY substr(genwordbase,0,%s)",level,whereToSQL,whereToSQL2,level);
		ResultSet rs = this.stat.executeQuery(sql);
		int pocet = 0;
		String np = null;
		HashMap<String, Integer> gm = new HashMap<String, Integer>();
		HashMap<String, Integer> mgm = new HashMap<String, Integer>();
		
		while(rs.next())
		{
			pocet = rs.getInt(1);
			np = rs.getString(2);
			//System.out.println(String.format("CHAR:%s Count:%S",np,pocet));
			//String mgenVal = whereNormWordCondition + KeyboardtUtils.getMoreGeneralizedString(np.substring(level-1));
			String mgenVal = np;
			if(mgm.containsKey(mgenVal))
				mgm.put(mgenVal, mgm.get(mgenVal) + pocet);
			else
				mgm.put(mgenVal, pocet);
		}
		rs.close();
		
		System.out.println("-------MOREGEN-------");
		for(String s : mgm.keySet())
		{
			int pct = mgm.get(s);
			System.out.println(String.format("CHAR:%s Count:%S",s,pct));
			if(pct > 2000)
			{
				testSubSize(whereNormWordCondition, s,level + 1);
			}
			else
			{
				String tbl = whereNormWordCondition.toUpperCase();
				String sqlq = null;
				
				if(whereGenWordCondition == null)
				{
					String sqlt = "select wordbase, normwordbase, searchtext, gensearchtext, genmoresearchtext, isbwu, suffix, cntr, wrdlen " +
					  "INTO %s FROM COMPLETE WHERE %s ";
					sqlq = String.format(sqlt,tbl,whereToSQL);
				}
				else
				{
					String sqlt = "select wordbase, normwordbase, searchtext, gensearchtext, genmoresearchtext, isbwu, suffix, cntr, wrdlen " +
					  "INTO %s FROM COMPLETE WHERE %s AND %s ";
					tbl = tbl + "-" + whereGenWordCondition;
					sqlq = String.format(sqlt,tbl,whereToSQL,whereToSQL2);
				}
				System.out.println(sqlq);
				
			}
			
			
		}
//		System.out.println("------GEN---------");
//		
//		for(String s : gm.keySet())
//		{
//			System.out.println(String.format("CHAR:%s Count:%S",s,gm.get(s)));
//		}
		System.out.println("-----END----------");
		
	}
	
	
	public String getDistinctString(String source)
	{
		HashSet<Character> chars = new HashSet<Character>();
		StringBuilder sb = new StringBuilder();
		for(char c : source.toCharArray())
		{
			if(!chars.contains(c))
			{
				sb.append(c);
				chars.add(c);
			}
		}
		return sb.toString();
	}
	
	 public void testSearch(String column, String test) throws SQLException 
	 {
		
		 String g = this.getCode(test);
		 String tpl = "SELECT * FROM \"CNe\" WHERE " + column + " MATCH '" + test + "*';";
		 //String tpl = "SELECT * FROM \"Test\";";
		 //String sql = String.format(tpl, "s");
		 String sql = tpl;
		 ResultSet rs = this.stat.executeQuery(sql);
		 while(rs.next())
		 {			 
			 System.out.println(rs.getString(1) + ";" + rs.getString(2));
		 }
		 
		 /*rs = this.stat.executeQuery("SELECT * FROM \"Test\"");
		 while(rs.next())
		 {			 
			 System.out.println(rs.getString(1) + ";" + rs.getString(2));
		 }*/
		 rs.close();		 
	 }
	 
	Connection conn = null;
     Statement stat = null;
     
	    
	public void createTable() throws SQLException
	{
		String template = "CREATE VIRTUAL TABLE  \"Test\" USING fts3(\"wordbase\" TEXT NOT NULL, \"Code\" TEXT, tokenize=porter);";
		this.stat.execute(template);		   
	}
	
	public void fillTable() throws SQLException
	{
		this.stat.execute("DELETE FROM Test");
		String[] s = new String[] {"ahoj", "kurva", "kokot", "kobliha", "frustrated"};
		String tpl = "INSERT INTO \"Test\" (\"wordbase\" , \"Code\") VALUES (\"%s\",\"%s\");";
		for(String word:s)
		{
			String sql = String.format(tpl, word,this.getCode(word));
			this.stat.execute(sql);
		}
	}
	
	public void testVypocet(String prefix) throws SQLException
	{
		ResultSet rs = this.stat.executeQuery("SELECT wordbase,normwordbase,suffix,isbwu,searchtext, offsets(C112) as off FROM C112 WHERE C112 MATCH  \"'p e l e c h u' 'pele*'\"");
		int prefixLen = prefix.replace(" ","").length();
		while(rs.next())
		{
			String offset = rs.getString("off");
			String word = rs.getString("normwordbase");
			String search = rs.getString("searchtext");
			boolean cmpr = compareOffsets(2, prefixLen, offset);
			if(cmpr)
				System.out.print(String.format("OK - Prefix:%s Word:%s SearchText:%s Compare:%s\n",prefix, word, search,cmpr));
//			else
//				System.out.print(String.format("nOK - Prefix:%s Word:%s SearchText:%s Compare:%s\n",prefix, word, search,cmpr));
		}
	}
	
	public boolean compareOffsets(int columnIndex, int prefixLen, String offsets)
	{
		prefixLen = prefixLen - 1; //last char is on index 3
		String[] aOffsets = offsets.split(" ");
		int lastIndexOfTermToSearch = 0;
		int laststartIndexInSearchedTerm = 0;
		for(int i = 0;i<aOffsets.length;i += 4)
		{
			int column = Integer.parseInt(aOffsets[i]);
			if(column > columnIndex)
				break;
			
			if(column == columnIndex)
			{
				int indexOfTermToSearch = Integer.parseInt(aOffsets[i + 1]);
				int startIndexInSearchedTerm = Integer.parseInt(aOffsets[i + 2]);
				if(startIndexInSearchedTerm == 0 && indexOfTermToSearch == 0)
				{
					continue;
				}
				else if(startIndexInSearchedTerm > 0 && indexOfTermToSearch > 0)
				{
					if(indexOfTermToSearch == lastIndexOfTermToSearch + 1)
					{
						lastIndexOfTermToSearch = indexOfTermToSearch;
						laststartIndexInSearchedTerm = startIndexInSearchedTerm;
					}
					else if(indexOfTermToSearch < lastIndexOfTermToSearch || startIndexInSearchedTerm == laststartIndexInSearchedTerm)
					{
						//repeated char before
					}
					else
						return false;
				
				}
				
				if(lastIndexOfTermToSearch == prefixLen)
					break;
			}
		}
		return true;
	}
	
	public String getCode(String word)
	{
		StringBuilder sb = new StringBuilder();
		char[] chars = word.toCharArray();
		for(char c : chars)
		{
			sb.append(getAroundKeys(c) + "|");
		}
		return sb.toString().trim();
	}
	
	public static String getAroundKeys(char c)
	{
		String result = "";
		
		if(c == 'a')
			result = "aqwsz";
		else if(c == 'b')
			result = "bvghjn";
		else if(c == 'c')
			result = "cxdfgv";
		else if(c == 'd')
			result = "dserfcx";
		else if(c == 'e')
			result = "erfdsw";
		else if(c == 'f')
			result = "fdrtgvcx";
		else if(c == 'g')
			result = "gftyhbvc";
		else if(c == 'h')
			result = "hgyujnbv";
		else if(c == 'i')
			result = "iolkju";
		else if(c == 'j')
			result = "jhuikmnb";		
		else if(c == 'k')
			result = "kjiolmn";
		else if(c == 'l')
			result = "lmkop";
		else if(c == 'm')
			result = "mnjkl";
		else if(c == 'n')
			result = "nbhjkm";
		else if(c == 'o')
			result = "oplki";
		else if(c == 'p')
			result = "pol";
		else if(c == 'q')
			result = "qwa";
		else if(c == 'r')
			result = "ertfd";
		else if(c == 's')
			result = "sawedxz";
		else if(c == 't')
			result = "rtyhgf";
		else if(c == 'u')
			result = "uyijh";
		else if(c == 'v')
			result = "vcfghb";
		else if(c == 'w')
			result = "qwesa";
		else if(c == 'x')
			result = "xzsdfc";
		else if(c == 'y')
			result = "tyuhg";
		else if(c == 'z')
			result = "asdxz";		
		return result;
	}
}
